/*
** $PROJECT: HyperText-DataType-System
**
** $VER: aminet.rexx 40.1 (26.10.96)
**
** $AUTHOR: Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** $COPYRIGHT: (C) Copyright 1996 by Stefan Ruppert, All Rights Reserved!
**
** $EMAIL: Stefan.Ruppert@informatik.fh-wiesbaden.de
**
** $REQUIRES: TCP/IP-Stack, FtpMount
**
** $HISTORY:
**
** 26.10.96 : 040.001 : initial
**
*/

Options Results

Parse Arg args

/* --------------------------- needed libraries --------------------------- */

Call AddLib('rexxsupport.library',0,-30,0)
Call AddLib('rexxdossupport.library',0,-30,0)

/* -------------------------- customize section --------------------------- */

aminet.site      = 'ftp.uni-paderborn.de'
/*aminet.site     = 'localhost'*/
aminet.dir       = 'aminet'
/*aminet.dir      = 'pub/aminet'*/
aminet.localdir = 'Backup:download'

/* ------------------------ end customize section ------------------------- */

If ReadArgs(args,'FILE/A,SITE/K,DIR/K,LOCALDIR/K,QUIET/S','AMINET.') Then Do

   If ~ShowList('h','FTP') Then Do
      Address Command 'Mount ftp:'

      If ~ShowList('h','FTP') Then Do
	 Say 'Cannot mount ftp-handler.'
	 Exit 10
      End
   End

   cmd = 'copy FROM="ftp://' || aminet.site || '/' || aminet.dir || '/' || aminet.file || '" TO="' || aminet.localdir || '"'

   If ~aminet.quiet Then
      Say 'Running: ' || cmd

   Options Failat 21

   Address Command cmd

   If RC = 0 Then Do
      If ~aminet.quiet Then Do
	 localfile  = AddPart(aminet.localdir, FilePart(aminet.file))
	 Say 'Aminet download for ' || aminet.file || ' finished :'
	 Address Command 'List ' || localfile || ' NOHEAD'
      End
   End
   Else If ~aminet.quiet Then
      Say 'Aminet download for ' || aminet.file || ' failed !'
End

