/*
** $PROJECT: HyperText-DataType-System
**
** $VER: HyperGuide2HTML.rexx 40.2 (20.12.97)
**
** $AUTHOR: Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** $COPYRIGHT: (C) Copyright 1997 by Stefan Ruppert, All Rights Reserved!
**
** $EMAIL: ruppert@amigaworld.com
**
** $HISTORY:
**
** 20.12.97 : 040.002 : added PORT/K template item and support for UniView
** 05.01.97 : 040.001 : initial
**
*/

Options Results

Parse Arg args

/* --------------------------- needed libraries --------------------------- */

Call AddLib('rexxsupport.library',0,-30,0)
Call AddLib('rexxdossupport.library',0,-30,0)

Parse Arg args

rxport        = ''
stem.dest     = ''
stem.port     = ''
stem.verbose  = 1
stem.debug    = 0
stem.nodir    = 0

template = 'DEST/A,PORT/K,VERBOSE/S,NODIR/S,DEBUG/S'

If ReadArgs(args,template,'STEM.') Then Do

   If STEM.PORT = '' Then Do
      STEM.PORT = 'MULTIVIEW.1.1'

      If ~Show('P',STEM.PORT) Then
	 STEM.PORT = 'UNIVIEW.1.1'
   End

   ADDRESS VALUE STEM.PORT

   'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=MAIN'

   If Upper(main) ~= 'MAIN' Then Do
      'LINK MAIN'

      'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=MAIN'
      If Upper(main) ~= 'MAIN' Then Do
	 Say 'The script cannot link to the main node'
	 Exit 10
      End
   End

   'GETATTR OBJECT=OBJECT FIELD=PATH VAR=PATH'

   filename = FilePart(path)
   p = Pos('.hguide',filename)
   If p > 0 Then
      filename = Left(filename,p - 1)
   Else Do
      p = Pos('.guide',filename)
      If p > 0 Then
	 filename = Left(filename,p - 1)
   End

   filename = ToLower(filename)
   basename = filename

   subdir = AddPart(stem.dest,basename)
   file = ToLower(AddPart(subdir,'main.html'))

   if stem.verbose Then
      Say 'Converting main node to : ' || file
   If ~Exists(subdir) Then
      Call MakeDir(subdir)
   'EXPORT TYPE=HTML FILE="' || file || '" ARGS=LOWER'

   done = 0
   do until done
      'NEXTINTERNAL'
      If RC=0 Then Do

	 If ~Exists(subdir) Then Do
	    Say 'Cannot create sub directory : ' || subdir
	    Exit 10
	 End

	 status = ''
	 Do until status = 'OK'
	    'GETATTR OBJECT=OBJECT FIELD=STATUS VAR=STATUS'
	    If stem.debug Then
	       Say status
	    Call Delay(5)
	 End

	 'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=NODE'
	 nodefile = node
	 p = Pos('.',nodefile)
	 If p > 0 Then
	    nodefile = Left(nodefile,p - 1)
	 nodefile = nodefile || '.html'

	 file = ToLower(AddPart(subdir,nodefile))

	 if stem.verbose Then
	    Say 'Converting node="' || node || '" to : ' || file

	 'EXPORT TYPE=HTML FILE="' || file || '" ARGS=LOWER'
      End
      Else
	 done = 1
   End
End
Else Do
   /*
   ioerr = GetVar(process,'local')
   Say ioerr
   Say Fault(116,'HyperGuide2HTML')
   */
   Say 'Template : ' || template
End
Exit

ToLower:

   return Translate(Arg(1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')

